#include "Stack.h"

Byte buffer[BUFFER_SIZE];


/*#######################################################
# Funktion um die Checksumme zu berechnen, stammt 		#
# ursprnglich von										#
# Ulrich Radig :-),www.ulrichradig.de 					#
# wer genaueres zur Checksummenbildung wissen mchte:	#
# http://www.netfor2.com/udpsum.htm 	 				#
########################################################*/
Word checksum (Byte * pointer,DWord result32,Word result16)
{
   Word result16_1 = 0x0000;
   Byte DataH;
   Byte DataL;

   //Jetzt werden alle Packete in einer While Schleife addiert
   while(result16 > 1)
   {
      //schreibt Inhalt Pointer nach DATAH danach inc Pointer
      DataH=*pointer++;

      //schreibt Inhalt Pointer nach DATAL danach inc Pointer
      DataL=*pointer++;

      //erzeugt Int aus Data L und Data H
      result16_1 = ((DataH << 8)+DataL);
      //Addiert packet mit vorherigen
      result32 = result32 + result16_1;
      //decrimiert Lnge von TCP Headerschleife um 2
      result16 -=2;
   }

   //Ist der Wert result16 ungerade ist DataL = 0
   if(result16 > 0)
   {
      //schreibt Inhalt Pointer nach DATAH danach inc Pointer
      DataH=*pointer;
      //erzeugt Int aus Data L ist 0 (ist nicht in der Berechnung) und Data H
      result16_1 = (DataH << 8);
      //Addiert packet mit vorherigen
      result32 = result32 + result16_1;
   }

   //Komplementbildung (addiert Long INT_H Byte mit Long INT L Byte)
   result32 = ((result32 & 0x0000FFFF)+ ((result32 & 0xFFFF0000) >> 16));
   result32 = ((result32 & 0x0000FFFF)+ ((result32 & 0xFFFF0000) >> 16));	
   result16 =~(result32 & 0x0000FFFF);

   return (result16);
}



/*	Funktionen, um zu berprfen, ob das Packet fr uns bestimmt ist, weitere Prf'routinen'
	sind als Macros in stack.h definiert, da sie unabhngig von der IP immer auf dieselbe Art
	geprft werden knnen
######################################################################################*/
uint8_t Checkmymac(void)
{
   if(buffer[0] == mymac[0] && buffer[1] == mymac[1] && buffer[2] == mymac[2] && buffer[3] == mymac[3] && buffer[4] == mymac[4] && buffer[5] == mymac[5])return(1);
   return(0);
}

uint8_t Checkmyip(void)
{
   if(buffer[38] == myip[0] && buffer[39] == myip[1] && buffer[40] == myip[2] && buffer[41] == myip[3])return(1);
   return(0);
}

/*Funktion um den Ethernet II Header zu erzeugen
####################################################################################*/
void Ethernet_II_Header_erzeugen(Byte *buff)
{
   for(Byte a=0; a<6; a++)
   {		
      buff[a] = buff[a+6];
      buff[a+6] = mymac[a];
   }
}
/*Funktion um den IP Header zu erzeugen
####################################################################################*/
void IP_Header_erzeugen(Byte *buff)
{
   struct IP_Header *ip;
   Word sum;

   ip = (struct IP_Header *)&buff[24];

   for(Byte a=0;a<4; a++)
   {		
      ip->IP_destIp[a] = ip->IP_sourceIp[a];
      ip->IP_sourceIp[a] = myip[a];
   }


   ip->IP_checksum = 0x00; // checksum auf null setzen
   sum = checksum(&buff[14],0x00000000,20); // checksumme ausrechnen

   ip->IP_checksum = ((sum & 0xFF00) >> 8)|((sum & 0x00FF)<<8); 
}
