//---------------------------------------------------------------------------
// Klasse     : Standard
// Datei      : Standard.h
// Datum      : 11.06.2007
// Version    : 1.0
// Autor      : Karsten Donat
//---------------------------------------------------------------------------

#ifndef _STANDARD_H_
#define _STANDARD_H_

#include <avr/io.h>

// Bitoperationen
//#define setBit  (Ziel,Bit) (Ziel |=  Bit)
//#define clearBit(Ziel,Bit) (Ziel &= ~Bit)

/* Define bit macros, note that they are similar to the I/O macros*/
#define SetBit(x,y)   (x |= (1<<y))     /* Set   bit y in byte x */
#define ClearBit(x,y) (x &= (~(1<<y)))  /* Clear bit y in byte x */
#define CheckBit(x,y) ((x & (1<<y))>>y) /* Check bit y in byte x */ 
//#define CheckBit(x,y) (x & (1<<y))     /* Check bit y in byte x */ 

// Datentypen
#define uchar unsigned char
#define uint  unsigned int

/*
typedef signed char        int8_t;
typedef unsigned char      uint8_t;
 
typedef short              int16_t;
typedef unsigned short     uint16_t;
 
typedef long               int32_t;
typedef unsigned long      uint32_t;
 
typedef long long          int64_t;
typedef unsigned long long uint64_t;
*/

// Datentypen quivalent zu Delphi
typedef          char       Shortint;   //        -128..127          8 Bit, mit  Vorzeichen
typedef          short      Smallint;   //      -32768..32767       16 Bit, mit  Vorzeichen
typedef          long       Integer;    // -2147483648..2147483647  32 Bit, mit  Vorzeichen
typedef          long long  Int64;      //       -2^63..2^63-1      64 Bit, mit  Vorzeichen
typedef unsigned char       Byte;       //           0..255          8 Bit, ohne Vorzeichen
typedef unsigned char       Char;       //           0..255          8 Bit, ohne Vorzeichen
typedef unsigned short      Word;       //           0..65535       16 Bit, ohne Vorzeichen
typedef unsigned long       DWord;      //           0..4294967295  32 Bit, ohne Vorzeichen
typedef unsigned long long  QWord;      //           0..2^64-1      64 Bit, ohne Vorzeichen

typedef unsigned char       Boolean;

typedef char*               String;


int Standard_Create();
int Standard_Destroy();

void delay_ms_grob(double ms);
void IntToStr( int z, char* Buffer );
void DWordToStr( DWord z, char* Buffer );

#define TERMINATE 1
#define DONT_TERMINATE 0
#define Terminate_Windows 2


/*einfache memcpy*/ 
Word Print_in_Buffer(Byte *buff,Byte *text,Byte terminate);
extern Word Print_in_Buffer_Flash_p(Byte *buff,const Byte *text,Byte terminate);
//#define Print_in_Buffer_Flash(__b,__s,__t) Print_in_Buffer_Flash_p(__b,PSTR(__s),__t)
Byte compare(Byte *buffone, Byte *bufftwo);

void Speicher_kopieren(Byte *Quelle,Byte *Ziel,Byte Laenge);

// liefert den momentan freien Speicher
// __heap_start is declared in the linker script
extern unsigned char __heap_start;
#define momentan_frei_ (SP - (Word) &__heap_start)      //Word momentan_frei_ = SP - (Word) &__heap_start;

#define AZ "\x22"
#define CRLF "\x0D\x0A"


#endif
