//---------------------------------------------------------------------------
// Klasse     : Uhr
// Datei      : Uhr.h
// Datum      : 18.06.2007
// Version    : 1.0
// Autor      : Karsten Donat
//---------------------------------------------------------------------------

#ifndef _UHR_H_
#define _UHR_H_

#include <avr/interrupt.h>
#include "Standard.h"

// globale Variablen
   #define DEBOUNCE	256L		// debounce clock (256Hz = 4msec)
   extern uchar prescaler;

   extern volatile Byte Tag;
   extern volatile Byte Monat;
   extern volatile Word Jahr;
   extern volatile Byte Stunde;
   extern volatile Byte Minute;
   extern volatile Byte Sekunde;
   extern volatile DWord Ticks;
   extern volatile Boolean Update_Zeit;
   extern volatile Boolean Update_Datum;


int Uhr_Create(Boolean Enable_Interupt=true);
int Uhr_Destroy();

void Uhr_SetDateTime(Byte nTag, Byte nMonat, Word nJahr, Byte nStunde, Byte nMinute, Byte nSekunde);

//char* TimeToString();
//char* DateTimeToString();

ISR (TIMER1_COMPA_vect);

void ItoA_Zeit( int z, char* Buffer );

// gibt Datum und Zeit als String zurck (Nullterminiert, Puffergre 20 Bytes!)
void DateTimeToStr( char* Buffer );


//void Delay(Byte ms);

#endif
